/* VzImagination (C) 2018-2019 Stephane Charette <stephanecharette@gmail.com>
 * $Id: TestMatManipSimpleColourBalance.cpp 2741 2019-04-09 17:04:20Z stephane $
 */

#include "TestUtil.hpp"


TEST(SimpleColourBalance, SimpleColourBalance)
{
	for (const auto & [path, name] : complex_test_images())
	{
		cv::Mat src = cv::imread(path);
		cv::Mat copy = src.clone();
		ASSERT_EQ(src.channels(), 3);

		cv::Mat dst = vz::apply_simple_colour_balance(src);
		ASSERT_EQ(dst.channels(), 3);

		cv::imwrite("simple_colour_balance_" + name + ".jpg", dst, {cv::IMWRITE_JPEG_QUALITY, 75, cv::IMWRITE_JPEG_OPTIMIZE, 1});

		ASSERT_FALSE(vz::compare_exact(src, dst));
		ASSERT_TRUE(vz::compare_exact(src, copy));
	}
}


TEST(SimpleColourBalance, Greyscale)
{
	// The original colour balance code assumed 3 channels, which would cause a segfault.
	// Make sure that doesn't happen.

	for (const auto & [path, name] : test_images())
	{
		cv::Mat src = cv::imread(path, cv::IMREAD_GRAYSCALE);
		ASSERT_FALSE(src.empty());
		ASSERT_EQ(src.channels(), 1);

		cv::Mat dst = vz::apply_simple_colour_balance(src);
		ASSERT_FALSE(dst.empty());
		ASSERT_EQ(dst.channels(), 1);
		cv::imwrite("greyscale_colour_balanced_" + name + ".jpg", dst, {cv::IMWRITE_JPEG_QUALITY, 75, cv::IMWRITE_JPEG_OPTIMIZE, 1});
	}
}
